// #autoload
// #name = _ZLakStats
// #category = ZephyrFox's Scripts
// #description = A comprehensive stat-tracker for LakRabbit.
// #version = 0.5
// #date = 01.18.2003
// #status = testing
// #author = Anthony Vrabel
// #warrior = ZephyrFox
// #email = ZephyrFox@hotmail.com
// #web = www.zephyrfox.com
// #credits =
// #readme =
// #config = ZLakStatsGUI
// #include = support/callback.cs
// #include = support/date_support.cs
// #include = support/player_support.cs
// #include = support/mission_callbacks.cs
// #include = support/mute_tools.cs

if(!isObject(ZLakStats))
{
	new ScriptObject(ZLakStats)
	{
		class = ZLakStats;
		version = "0.5";
	};
}

function ZLakStats::setup(%this)
{
	callback.add(CallbackMsgPlrPointBonus, "ZLakStats.clientPointBonus");
	callback.add(CallbackMsgDuelBonus, "ZLakStats.duelBonus");
	callback.add(CallbackMsgRabbitFlagTaken, "ZLakStats.flagTaken");
	callback.add(CallbackMsgRabbitFlagDropped, "ZLakStats.flagDropped");

	callback.add(onGameOver, "ZLakStats.saveStats");
	callback.add(onUserClientDrop, "ZLakStats.saveStats");

	if(!$ZLakStatsPrefs::firstRun)
	{
		$ZLakStatsPrefs::firstRun = 1;
		$ZLakStatsPrefs::firstRunDate = date("m.d.Y");
	}
}

function ZLakStats::clientPointBonus(%this, %msgType, %msgString, %points, %pluralPoints, %hitType, %weapon, %special, %distance, %speed, %accuracy)
{
	if(%weapon $= "Hand-Nade") %weapon = "HandNade";
	if(%weapon $= "Grenade-Launcher") %weapon = "GrenadeLauncher";
	if(%special $= "-in-the-back") %weapon = "Backlance";
	else if(%special $= " Headshot") %weapon = "Headshot";

	if(%weapon $= "Chaingun" || %weapon $= "HandNade" || %weapon $= "MINE")
	{
		%accuracy = getSubStr(%accuracy, 11, 2);
		if(%accuracy $= "10") %accuracy = 100;
	}
	else %accuracy = -1;

	%height = getControlObjectAltitude();

	if(strstr(%msgString, "Long-Distance") != -1) %hitType = "ld";
	else if(strstr(%msgString, "Mid-Air") != -1) %hitType = "ma";
	else %hitType = "other";

	$ZLakStats::allHits++;
	$ZLakStats::allWeapPoints += %points;
	$ZLakStats::allWeapDist += %distance;
	$ZLakStats::allWeapSpeed += %speed;
	$ZLakStats::allWeapHeight += %height;

	if(%points > $ZLakStats::recordAllPoints)
	{
		$ZLakStats::recordAllPoints = %points;
		$ZLakStats::recordAllPointsWeap = %weapon;
	}
	if(%distance > $ZLakStats::recordAllDist)
	{
		$ZLakStats::recordAllDist = %distance;
		$ZLakStats::recordAllDistWeap = %weapon;
	}
	if(%speed > $ZLakStats::recordAllSpeed)
	{
		$ZLakStats::recordAllSpeed = %speed;
		$ZLakStats::recordAllSpeedWeap = %weapon;
	}
	if(%height > $ZLakStats::recordAllHeight)
	{
		$ZLakStats::recordAllHeight = %height;
		$ZLakStats::recordAllHeightWeap = %weapon;
	}

	$ZLakStats::totalHits[%weapon]++;
	$ZLakStats::totalPoints[%weapon] += %points;
	$ZLakStats::totalDist[%weapon] += %distance;
	$ZLakStats::totalSpeed[%weapon] += %speed;
	$ZLakStats::totalHeight[%weapon] += %height;

	if(%points > $ZLakStats::recordPoints[%weapon]) $ZLakStats::recordPoints[%weapon] = %points;
	if(%distance > $ZLakStats::recordDist[%weapon]) $ZLakStats::recordDist[%weapon] = %distance;
	if(%speed > $ZLakStats::recordSpeed[%weapon]) $ZLakStats::recordSpeed[%weapon] = %speed;
	if(%height > $ZLakStats::recordHeight[%weapon]) $ZLakStats::recordHeight[%weapon] = %height;

	if(%accuracy > 0)
	{
		$ZLakStats::accurateHits[%weapon]++;
		$ZLakStats::totalAccuracy[%weapon] += %accuracy;
	}

	if(%hitType $= "ma")
	{
		$ZLakStats::allMAs++;
		$ZLakStats::allMApoints += %points;
		$ZLakStats::allMAdist += %distance;
		$ZLakStats::allMAspeed += %speed;
		$ZLakStats::allMAheight += %height;

		$ZLakStats::MAs[%weapon]++;
		$ZLakStats::MATotalPoints[%weapon] += %points;
		$ZLakStats::MATotalDist[%weapon] += %distance;
		$ZLakStats::MATotalSpeed[%weapon] += %speed;
		$ZLakStats::MATotalHeight[%weapon] += %height;

		if(%points > $ZLakStats::recordMAPoints[%weapon]) $ZLakStats::recordMAPoints[%weapon] = %points;
		if(%distance > $ZLakStats::recordMADist[%weapon]) $ZLakStats::recordMADist[%weapon] = %distance;
		if(%speed > $ZLakStats::recordMASpeed[%weapon]) $ZLakStats::recordMASpeed[%weapon] = %speed;
		if(%height > $ZLakStats::recordMAHeight[%weapon]) $ZLakStats::recordMAHeight[%weapon] = %height;
	}

	if(%hitType $= "ld")
	{
		$ZLakStats::allLDs++;
		$ZLakStats::allLDpoints += %points;
		$ZLakStats::allLDdist += %distance;
		$ZLakStats::allLDspeed += %speed;
		$ZLakStats::allLDheight += %height;

		$ZLakStats::LDs[%weapon]++;
		$ZLakStats::LDTotalpoints[%weapon] += %points;
		$ZLakStats::LDTotalDist[%weapon] += %distance;
		$ZLakStats::LDTotalSpeed[%weapon] += %speed;
		$ZLakStats::LDTotalHeight[%weapon] += %height;

		if(%points > $ZLakStats::recordLDPoints[%weapon]) $ZLakStats::recordLDPoints[%weapon] = %points;
		if(%distance > $ZLakStats::recordLDDist[%weapon]) $ZLakStats::recordLDDist[%weapon] = %distance;
		if(%speed > $ZLakStats::recordLDSpeed[%weapon]) $ZLakStats::recordLDSpeed[%weapon] = %speed;
		if(%height > $ZLakStats::recordLDHeight[%weapon]) $ZLakStats::recordLDHeight[%weapon] = %height;
	}

	if(%hitType $= "other")
	{
		$ZLakStats::allOthers++;
		$ZLakStats::allOtherpoints += %points;
		$ZLakStats::allOtherdist += %distance;
		$ZLakStats::allOtherspeed += %speed;
		$ZLakStats::allOtherheight += %height;

		$ZLakStats::others[%weapon]++;
		$ZLakStats::othersTotalPoints[%weapon] += %points;
		$ZLakStats::othersTotalDist[%weapon] += %distance;
		$ZLakStats::othersTotalSpeed[%weapon] += %speed;
		$ZLakStats::othersTotalHeight[%weapon] += %height;

		if(%points > $ZLakStats::recordOtherPoints[%weapon]) $ZLakStats::recordOtherPoints[%weapon] = %points;
		if(%distance > $ZLakStats::recordOtherDist[%weapon]) $ZLakStats::recordOtherDist[%weapon] = %distance;
		if(%speed > $ZLakStats::recordOtherSpeed[%weapon]) $ZLakStats::recordOtherSpeed[%weapon] = %speed;
		if(%height > $ZLakStats::recordOtherHeight[%weapon]) $ZLakStats::recordOtherHeight[%weapon] = %height;
	}
}

function ZLakStats::duelBonus(%this, %msgType, %msgString, %name, %points, %plural, %kills, %pluralPoints, %seconds, %pluralSeconds)
{
	if(Strstr(%msgString, "bonus point") != -1 && deTag(%name) $= PlayerList.getMyName())
	{
		$ZLakStats::DBs++;
		$ZLakStats::DBTotalPoints += %points;
		$ZLakStats::DBTotalKills += %kills;
		$ZLakStats::DBTotalSeconds += %seconds;

		if(%points > $ZLakStats::recordDBPoints) $ZLakStats::recordDBPoints = %points;
		if(%kills > $ZLakStats::recordDBKills) $ZLakStats::recordDBKills = %speed;
		if(%seconds > $ZLakStats::recordDBSeconds) $ZLakStats::recordDBSeconds = %height;
	}
}

function ZLakStats::flagTaken(%this, %msgType, %msgString, %name, %points, %speed, %height)
{
	if(deTag(%name) $= PlayerList.getMyName())
	{
		$ZLakStatsFCStartTime = mFloor(getSimTime());
		$ZLakStats::flagGrabs++;
	}

	if(Strstr(%msgString, "Mid-Air") != -1 && deTag(%name) $= PlayerList.getMyName())
	{
		$ZLakStats::MAgrabs++;
		$ZLakStats::MAgrabTotalPoints += %points;
		$ZLakStats::MAgrabTotalSpeed += %speed;
		$ZLakStats::MAgrabTotalHeight += %height;

		if(%points > $ZLakStats::recordMAgrabPoints) $ZLakStats::recordMAgrabPoints = %points;
		if(%speed > $ZLakStats::recordMAgrabSpeed) $ZLakStats::recordMAgrabSpeed = %speed;
		if(%height > $ZLakStats::recordMAgrabHeight) $ZLakStats::recordMAgrabHeight = %height;
	}
}

function ZLakStats::flagDropped(%this, %msgType, %msgString, %name)
{
	if(strstr(%msgString, "You") != -1)
	{
		$ZLakStatsFCEndTime = mFloor(getSimTime());
		%time = ($ZLakStatsFCEndTime-$ZLakStatsFCStartTime)/1000;
		if(%time > $ZLakStats::recordPossTime) $ZLakStats::recordPossTime = %time;
		$ZLakStats::totalPossTime += %time;
	}
}

function ZLakStats::deriveStats(%this)
{
	$ZLakStats::allPointEvents = 			$ZLakStats::allHits+$ZLakStats::MAgrabs+$ZLakStats::DBs;
	$ZLakStats::allPoints = 			$ZLakStats::allWeapPoints+$ZLakStats::MAgrabTotalPoints+$ZLakStats::DBTotalPoints;
	$ZLakStats::averagePoints = 			getSubStr(($ZLakStats::allPoints/$ZLakStats::allPointEvents), 0, 5);

	$ZLakStats::totalPossPoints = 			$ZLakStats::totalPossTime/2000;
	$ZLakStats::averagePossPoints = 		getSubStr(($ZLakStats::totalPossPoints/$ZLakStats::flagGrabs), 0, 5);
	$ZLakStats::averagePossLength =			getSubStr(($ZLakStats::totalPossTime/$ZLakStats::flagGrabs), 0, 5);

	$ZLakStats::averageAllWeapPoints = 		getSubStr(($ZLakStats::allWeapPoints/$ZLakStats::allHits), 0, 5);
	$ZLakStats::averageAllWeapDist = 		getSubStr(($ZLakStats::allWeapDist/$ZLakStats::allHits), 0, 5);
	$ZLakStats::averageAllWeapSpeed = 		getSubStr(($ZLakStats::allWeapSpeed/$ZLakStats::allHits), 0, 5);
	$ZLakStats::averageAllWeapHeight = 		getSubStr(($ZLakStats::allWeapHeight/$ZLakStats::allHits), 0, 5);

	$ZLakStats::averageAllMAPoints = 		getSubStr(($ZLakStats::allMApoints/$ZLakStats::allMAs), 0, 5);
	$ZLakStats::averageAllMADist = 			getSubStr(($ZLakStats::allMAdist/$ZLakStats::allMAs), 0, 5);
	$ZLakStats::averageAllMASpeed = 		getSubStr(($ZLakStats::allMAspeed/$ZLakStats::allMAs), 0, 5);
	$ZLakStats::averageAllMAHeight = 		getSubStr(($ZLakStats::allMAheight/$ZLakStats::allMAs), 0, 5);

	$ZLakStats::averageAllLDPoints = 		getSubStr(($ZLakStats::allLDpoints/$ZLakStats::allLDs), 0, 5);
	$ZLakStats::averageAllLDDist = 			getSubStr(($ZLakStats::allLDdist/$ZLakStats::allLDs), 0, 5);
	$ZLakStats::averageAllLDSpeed = 		getSubStr(($ZLakStats::allLDspeed/$ZLakStats::allLDs), 0, 5);
	$ZLakStats::averageAllLDHeight = 		getSubStr(($ZLakStats::allLDheight/$ZLakStats::allLDs), 0, 5);

	$ZLakStats::averageAllOtherPoints = 		getSubStr(($ZLakStats::allOtherpoints/$ZLakStats::allOthers), 0, 5);
	$ZLakStats::averageAllOtherDist = 		getSubStr(($ZLakStats::allOtherdist/$ZLakStats::allOthers), 0, 5);
	$ZLakStats::averageAllOtherSpeed = 		getSubStr(($ZLakStats::allOtherspeed/$ZLakStats::allOthers), 0, 5);
	$ZLakStats::averageAllOtherHeight = 		getSubStr(($ZLakStats::allOtherheight/$ZLakStats::allOthers), 0, 5);

	$ZLakStats::averageMAgrabPoints = 		getSubStr(($ZLakStats::MAgrabTotalPoints/$ZLakStats::MAgrabs), 0, 5);
	$ZLakStats::averageMAgrabSpeed = 		getSubStr(($ZLakStats::MAgrabTotalSpeed/$ZLakStats::MAgrabs), 0, 5);
	$ZLakStats::averageMAgrabHeight = 		getSubStr(($ZLakStats::MAgrabTotalHeight/$ZLakStats::MAgrabs), 0, 5);

	$ZLakStats::averageDBPoints = 			getSubStr(($ZLakStats::DBTotalPoints/$ZLakStats::DBs), 0, 5);
	$ZLakStats::averageDBKills = 			getSubStr(($ZLakStats::DBTotalKills/$ZLakStats::DBs), 0, 5);
	$ZLakStats::averageDBSeconds = 			getSubStr(($ZLakStats::DBTotalSeconds/$ZLakStats::DBs), 0, 5);

	$ZLakStats::percentWeapEvent = 			getSubStr((($ZLakStats::allHits/$ZLakStats::allPointEvents)*10), 0, 5);
	$ZLakStats::percentWeapPoints = 		getSubStr((($ZLakStats::allWeapPoints/$ZLakStats::allPoints)*10), 0, 5);

	$ZLakStats::percentMAgrabEvent = 		getSubStr((($ZLakStats::MAgrabs/$ZLakStats::allPointEvents)*10), 0, 5);
	$ZLakStats::percentMAgrabPoints = 		getSubStr((($ZLakStats::MAgrabTotalPoints/$ZLakStats::allPoints)*10), 0, 5);

	$ZLakStats::percentDBEvent = 			getSubStr((($ZLakStats::DBs/$ZLakStats::allPointEvents)*10), 0, 5);
	$ZLakStats::percentDBPoints = 			getSubStr((($ZLakStats::DBTotalPoints/$ZLakStats::allPoints)*10), 0, 5);
}

function ZLakStats::deriveWeaponStats(%this, %weapon)
{
	$ZLakStats::averagePoints[%weapon] = 		getSubStr(($ZLakStats::totalPoints[%weapon]/$ZLakStats::totalHits[%weapon]), 0, 5);
	$ZLakStats::averageDist[%weapon] = 		getSubStr(($ZLakStats::totalDist[%weapon]/$ZLakStats::totalHits[%weapon]), 0, 5);
	$ZLakStats::averageSpeed[%weapon] = 		getSubStr(($ZLakStats::totalSpeed[%weapon]/$ZLakStats::totalHits[%weapon]), 0, 5);
	$ZLakStats::averageHeight[%weapon] = 		getSubStr(($ZLakStats::totalHeight[%weapon]/$ZLakStats::totalHits[%weapon]), 0, 5);
	$ZLakStats::averageAccuracy[%weapon] = 		getSubStr(($ZLakStats::totalAccuracy[%weapon]/$ZLakStats::accurateHits[%weapon]), 0, 5);

	$ZLakStats::averageMAPoints[%weapon] = 		getSubStr(($ZLakStats::MATotalPoints[%weapon]/$ZLakStats::MAs[%weapon]), 0, 5);
	$ZLakStats::averageMADist[%weapon] = 		getSubStr(($ZLakStats::MATotalDist[%weapon]/$ZLakStats::MAs[%weapon]), 0, 5);
	$ZLakStats::averageMASpeed[%weapon] = 		getSubStr(($ZLakStats::MATotalSpeed[%weapon]/$ZLakStats::MAs[%weapon]), 0, 5);
	$ZLakStats::averageMAHeight[%weapon] = 		getSubStr(($ZLakStats::MATotalHeight[%weapon]/$ZLakStats::MAs[%weapon]), 0, 5);

	$ZLakStats::averageLDPoints[%weapon] = 		getSubStr(($ZLakStats::LDTotalPoints[%weapon]/$ZLakStats::LDs[%weapon]), 0, 5);
	$ZLakStats::averageLDDist[%weapon] = 		getSubStr(($ZLakStats::LDTotalDist[%weapon]/$ZLakStats::LDs[%weapon]), 0, 5);
	$ZLakStats::averageLDSpeed[%weapon] = 		getSubStr(($ZLakStats::LDTotalSpeed[%weapon]/$ZLakStats::LDs[%weapon]), 0, 5);
	$ZLakStats::averageLDHeight[%weapon] = 		getSubStr(($ZLakStats::LDTotalHeight[%weapon]/$ZLakStats::LDs[%weapon]), 0, 5);

	$ZLakStats::averageOtherPoints[%weapon] = 	getSubStr(($ZLakStats::othersTotalPoints[%weapon]/$ZLakStats::others[%weapon]), 0, 5);
	$ZLakStats::averageOtherDist[%weapon] = 	getSubStr(($ZLakStats::othersTotalDist[%weapon]/$ZLakStats::others[%weapon]), 0, 5);
	$ZLakStats::averageOtherSpeed[%weapon] = 	getSubStr(($ZLakStats::othersTotalSpeed[%weapon]/$ZLakStats::others[%weapon]), 0, 5);
	$ZLakStats::averageOtherHeight[%weapon] = 	getSubStr(($ZLakStats::othersTotalHeight[%weapon]/$ZLakStats::others[%weapon]), 0, 5);
}

function ZLakStats::loadPrefs()
{
	if(!$ZLakStatsPrefs::loaded)
	{
		exec("prefs/ZLakStats.prefs");
		$ZLakStatsPrefs::loaded = 1;
	}
}

function ZLakStats::savePrefs()
{
	export("$ZLakStatsPrefs::*", "prefs/ZLakStats.prefs", false);
}

function ZLakStats::loadStats()
{
	if(!$ZLakStats::loaded)
	{
		exec("stats/ZLakStats.stats");
		$ZLakStats::loaded = 1;
	}
}

function ZLakStats::saveStats()
{
	ZLakStats.deriveStats();

	for(%i=0; %i < 12; %i++)
	{
		%weapon = $ZLakStats::weaponIndex[%i];
		ZLakStats.deriveWeaponStats(%weapon);
	}

	export("$ZLakStats::*", "stats/ZLakStats.stats", false);
}

ZLakStats.loadPrefs();	
ZLakStats.loadStats();
ZLakStats.setup();

$ZLakStats::weaponIndex[0] = "Disc";
$ZLakStats::weaponIndex[1] = "GrenadeLauncher";
$ZLakStats::weaponIndex[2] = "Snipe";
$ZLakStats::weaponIndex[3] = "Chaingun";
$ZLakStats::weaponIndex[4] = "HandNade";
$ZLakStats::weaponIndex[5] = "Mortar";
$ZLakStats::weaponIndex[6] = "MINE";
$ZLakStats::weaponIndex[7] = "Blaster";
$ZLakStats::weaponIndex[8] = "Plasma";
$ZLakStats::weaponIndex[9] = "Shocklance";
$ZLakStats::weaponIndex[10] = "Backlance";
$ZLakStats::weaponIndex[11] = "Headshot";

function ZLakStatsGUI::onWake(%this)
{
	%Hres = getWord($pref::Video::resolution, 0);

	switch(%Hres)
	{
		case 1600:	%HGUIext = 1360;
				%VGUIext = 1073;

				%HPANext = 1340;
				%VPANext = 1053;

				%HSCRext = 1310;
				%VSCRext = 1013;

				%HCONext = 1285;
				%VCONext = 988;

		case 1280:	%HGUIext = 1040;
				%VGUIext = 897;

				%HPANext = 1020;
				%VPANext = 877;

				%HSCRext = 990;
				%VSCRext = 837;

				%HCONext = 965;
				%VCONext = 812;

		case 1024:	%HGUIext = 784;
				%VGUIext = 641;

				%HPANext = 764;
				%VPANext = 621;

				%HSCRext = 734;
				%VSCRext = 581;

				%HCONext = 709;
				%VCONext = 556;

		case 800:	%HGUIext = 560;
				%VGUIext = 473;

				%HPANext = 540;
				%VPANext = 453;

				%HSCRext = 510;
				%VSCRext = 413;

				%HCONext = 485;
				%VCONext = 388;

		default:	%HGUIext = 784;
				%VGUIext = 641;

				%HPANext = 764;
				%VPANext = 621;

				%HSCRext = 734;
				%VSCRext = 581;

				%HCONext = 709;
				%VCONext = 556;
	}

	ZLakStatsGUI.setExtent(%HGUIext, %VGUIext);
	ZLakStatsPane.setExtent(%HPANext, %VPANext);
	ZLakStatsScroll.setExtent(%HSCRext, %VSCRext);
	ZLakStatsContent.setExtent(%HCONext, %VCONext);
}

//--- OBJECT WRITE BEGIN ---
new GuiControl(ZLakStatsGUI) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "5 12";
	extent = "800 600";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl(ZLakStatsPane) {
		profile = "ShellPaneProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "800 600";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "ZLakStats";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";
	};
	new ShellScrollCtrl(ZLakStatsScroll) {
		profile = "NewScrollCtrlProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "15 25";
		extent = "770 561";
		minExtent = "24 24";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		willFirstRespond = "1";
		hScrollBar = "dynamic";
		vScrollBar = "dynamic";
		constantThumbHeight = "0";
		defaultLineHeight = "15";
		childMargin = "0 0";
		fieldBase = "gui/shll_field";

		new GuiScrollContentCtrl(ZLakStatsContent) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "4 4";
			extent = "746 537";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiControl(ZLakStatsCanvas) {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "1280 1024";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";

				new GuiTextCtrl() {
					profile = "GuiTextProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "0 0";
					extent = "38 20";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					text = "ZLakStats average points " @ $ZLakStats::averagePoints;
					longTextBuffer = "0";
					maxLength = "255";
				};
			};
		};
	};
};
//--- OBJECT WRITE END ---